%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%                  funzione primo - esercizio 2                    %
%           Esercitazione in laboratorio del 20/2/2009             %
%******************************************************************%
%
%       function out=primo(n)
%
% Funzione che, fornito in input un numero (1x1), indica se questo  primo.
% Nel caso che lo sia, il valore in uscit sar '1', nel caso contrario '0'


function out=primo(n)

%Si inizializza il valore di uscita in un caso di default, per garantire
%un valore in uscita.
out=1; 

%  possibile pensare di ottimizzare l'algoritmo di ricerca del numero
% primo escludendo a priori casi noti, abbassando cos il tempo di
% esecuzione della funzione.
% Esempio di casi noti: 
% -1,2,3 sono primi;
% - sono non primi i numeri pari (numeri divisibili per 2); 
% NB: divisore se il resto della divisione  '0'. Usare la funzione 'rem'

% si prende in esame il valore assoluto del numero importato
n=abs(n);
%in alternativa, si pu fare un controllo sul dato immesso, che non
%dev'essere negativo

if n<=3 % i numeri 1,2 e 3 sono primi
    out=1;
elseif rem(n,2)==0 % mentre tutti i numeri pari sono NON primi
    out=0;
else % per gli altri casi, dobbiamo provare tutti i divisori 
    for divisore=3:2:sqrt(n) % solo divisori dispari, da 3 fino a radice di n
        if rem(n,divisore)==0 % c' un divisore, quindi non  primo!
            out=0;
            break;
        end
    end
end