%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%                  funzione principale5 - esercizio 5              %
%           Esercitazione in laboratorio del 20/2/2009             %
%******************************************************************%
%
%   function principale2(corsi, orainizio, durata)
%
% Risolve l'esercizio 5. Richiede di aver importato da IW 3 vettori
% corsi: contiene i nomi dei corsi;
% ora inizio: contiene tutti gli orari di inizio lezione
% durata: contiene la durata (in ora) delle lezioni di ogni corso

function principale5(corsi, orainizio, durata)

%pulizia ambiente
close all
clc

%visualizzo i dati nei vettori in ingresso
visualizza(corsi, orainizio, durata);

%richiesta da command window del nuovo corso da inserire
nuovocorso=input('inserire il nome del nuovo corso: ','s');
nuovoinizio=input('ora inizio: ');
nuovadurata=input('durata: ');

%Stampo a video tutti i corsi che si sovrappongono con la nuova materia (se
%ve ne sono)

%posso inizializzare un contatore per contare il numero di sovapposizioni
%trovate (non richiesto nel testo)
count=0; 

for i=1:length(orainizio)
    if sovrappone(nuovoinizio, nuovadurata, orainizio(i),durata(i))
        fprintf(1,'sovrapposto con: %s\n', char(corsi(i)));
        count=count+1;
    end
end

%se non ci sono sovrapposizioni, un messaggio informa della mancanza di
%sovrapposizioni. 

if count==0
    fprintf(1,'\n Non ci sono sovrapposizioni\n');    
end


%------------------------- Fine di principale2 ---------------------------

%% function visualizza(corsi, orainizio, durata)
% visualizza il contenuto dei dati sul command window, in tabella 
function visualizza(corsi, orainizio, durata)
for i=1:length(orainizio)
    fprintf(1,'%s \t %g \t %g \n',char(corsi(i)),orainizio(i),durata(i));
end

%% function out=sovrappone(orainizio1,durata1,orainizio2,durata2)
% Realizza quanto richiesto nel punto 2;
% fornisce '1' nel caso che due lezioni si sovrappongano; in ingresso viene
% richiesta l'inizio e la durata della lezione

function out=sovrappone(orainizio1,durata1,orainizio2,durata2)

% La difficolt  solo nell'individuare il test per discriminare i due casi
% (lezione sovrapposta o lezione non sovrapposta)

if (orainizio1<orainizio2+durata2 & orainizio2<orainizio1+durata1)
    out=1;
else
    out=0;
end
