%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%                  funzione primo - esercizio 1                    %
%           Esercitazione in laboratorio del 20/2/2009             %
%******************************************************************%
%
%   function ternepitagoriche(n)
%
%Funzione che visualizza le terne pitagoriche con valori nell'intervallo
%[1:n]. NOta: la funzione non restituisce niente!

function ternepitagoriche(n)

%Si tratta di realizzare tutte le combinazioni possibili, assegnando alle
%variabili a,b,c un numero intero tra [1:n]. Ogni combinazione ottenuta
%andr valutata con un test: se  terna pitagorica (a^2+b^2=c^2), allora 
%tale terna viene visualizzata

%Si pu rendere l'algoritmo pi rapido, osservando che la somma 
%commutativa. Quindi  inutile valutare tutte le combinazioni, dato che
%molte sono gi state valutate.
% Esempio: a=2 e b=1  analogo a a=1 e b=2!
% Dal punto di vista matematico, basta valutare una delle due variabili
% nella condizione a<b (o b<a, a scelta).

%Altra migliora  apportata osservando che l'ipotenusa di un triangolo (c) 
% non pu MAI essere pi lunga della somma dei due cateti (a+b).
% pertanto, valori che non rispettano tale condizioni non saranno terne
% pitagoriche, e possono essere scartati a priori


for a=1:n %ciclo che valuta il parametro a nell'intervallo [1:n]
    for b=a:n % abbiamo richiesto a<b, b valutato in [a:n],a  definito nel ciclo precedente
        for c=b:a+b % l'ipotenusa non pu essere pi lungo di a+b
            if (a^2+b^2)==(c^2) %condizione di terna pitagorica
                fprintf(1,'trovata la terna: %g %g %g \n',a,b,c);
            end
        end
    end
end