%                     Universita' di Ferrara                       %
%                                                                  %
%                Corso di informatica industriale                  %
%                                                                  %
%            funzione principale - esercizio 4                     %
%******************************************************************%
%
%
% La funzione princiaple prende in ingresso:
% - un vettore di celle contenente i nomi : 'nomi'
% - una matrice di valori contenente i voti di tutti gli studenti: 'voti'
function principale (nomi,voti)

D = size(voti); 
N = D(1) ; %numero totale di studenti (numero di righe della matrice)

fileID = fopen('resoconto.txt','w');

%Per calcolare la media degli studenti devo utilizzare le funzioni NonNulli
%e mediaNonNulli per ogni riga della matrice 'voti'. Per fare questo
%utilizzo un ciclo for con indice i che va da 1 al numero totale di
%studenti N
for i = 1:N
    
    % il numero di esami sostenuti dallo studente i-esimo
    % si calcola usando a funzione "NonNulli"
    NesamiNonNulli = NonNulli(voti(i,:)); 
    
    % la media dei voti dello studente i-esimo
    % si calcola usando a funzione "mediaNonNulli"
    media = mediaNonNulli(voti(i,:)); 
    
    %nome dello studente i-esimo
    nome = char(nomi(i)); 
    
    % Stampo a video (e sul file)
    fprintf('%s: %g esami, media = %g\n',nome,NesamiNonNulli,media) %stampo a video i risultati per lo studente i-esimo
    fprintf(fileID,'%s: %g esami, media = %g\n',nome,NesamiNonNulli,media); %salvo i risultati in un file resoconto.txt per lo studente i-esimo
   
end

fclose(fileID);