%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%                  funzione inserimento - esercizio 3              %
%           Esercitazione in laboratorio del 20/2/2009             %
%******************************************************************%
%
%   function out=inserimento
%
% La funzione computa il massimo in un insieme di valori forniti
% dall'utente
% Nota: la funzione non ha input! In uscita restituisce il massimo di un
% insieme di valori inseriti da command  window (una volta invocata la
% funzione), per iterazione con l'utente.

function out=inserimento

%Si suddivide la funzione in due parti:
% 1) Inserimento dati (da parte dell'utente
% 2) Ricerca del valore massimo tra quelli inseriti (senza usare la
% funzione max!
% 3)Output risultati

%% Inserimento dati utente

%Si salvano i valori inseriti in un vettore x:  bene inizializzarlo
%inizialmente (vettore vuoto)
x = []; 

% I dati vengono catturati con la funzione 'input'
new = input('enter value '); %primo dato, almeno deve esserci

%controllo sul dato immesso, si continua a chiedere un dato fintanto che
%non si immette un dato vuoto. In altre parole, si 'cicla' la richiesta del
%dato (con l'input) finch questo non risulta vuoto (per questo si esegue
%un test con la funzione isempty, vera (valore '1') se l'ultimo inserimento
% vuoto

while ~(isempty(new))
    x = [ x, new ]; %aggiorno il vettore x, ultimo dato in coda
    new = input('enter value '); %richiesta di nuovo input
end

%% Ricerca del massimo

%Si inizializza il massimo come -Inf, numero pi basso concepito da Matlab
massimo=-inf;

%Si procede confrontando ogni elemento nel vettore x con il valore massimo;
%se questo  superiore al massimo, allora  il nuovo massimo, altrimenti si
%procede fino alla fine del vettore
for n=x % n assume tutti i valori contenuti in x
    if n>massimo
        massimo=n;
    end
end

%% Output risultati
massimo %Visualizzo a command window il risultato
out=x; %Si pone in uscita il vettore completo dei dati inseriti

